package cn.com.infosec.asn1.x9;

import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1OctetString;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DEROctetString;
import cn.com.infosec.math.ec.ECFieldElement;
import java.math.BigInteger;

public class X9FieldElement extends ASN1Encodable {
   private static X9IntegerConverter converter = new X9IntegerConverter();
   protected ECFieldElement f;

   public X9FieldElement(ECFieldElement f) {
      this.f = f;
   }

   public X9FieldElement(BigInteger p, ASN1OctetString s) {
      X9FieldElement var10000 = this;
      ECFieldElement.Fp var4;
      ECFieldElement.Fp var10001 = var4 = new ECFieldElement.Fp;
      BigInteger var3;
      var3 = new BigInteger.<init>(1, s.getOctets());
      var10001.<init>(p, var3);
      var10000.<init>(var4);
   }

   public X9FieldElement(int m, int k1, int k2, int k3, ASN1OctetString s) {
      X9FieldElement var10000 = this;
      ECFieldElement.F2m var7;
      ECFieldElement.F2m var10001 = var7 = new ECFieldElement.F2m;
      BigInteger var6;
      var6 = new BigInteger.<init>(1, s.getOctets());
      var10001.<init>(m, k1, k2, k3, var6);
      var10000.<init>(var7);
   }

   public ECFieldElement getValue() {
      return this.f;
   }

   public DERObject toASN1Object() {
      int var1 = converter.getByteLength(this.f);
      byte[] var2 = converter.integerToBytes(this.f.toBigInteger(), var1);
      return new DEROctetString(var2);
   }
}
